## mapserver 6.4.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)

project (MapServer)

include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)



set (MapServer_VERSION_MAJOR 6)
set (MapServer_VERSION_MINOR 4)
set (MapServer_VERSION_REVISION 0)
set (MapServer_VERSION_SUFFIX "")

set(TARGET_VERSION_MAJOR ${MapServer_VERSION_MAJOR})
set(TARGET_VERSION_MINOR ${MapServer_VERSION_MINOR})

MATH(EXPR MapServer_IS_DEV_VERSION "${MapServer_VERSION_MINOR}%2")
if(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}-dev")
else(MapServer_IS_DEV_VERSION)
  set (MapServer_VERSION_STRING "${MapServer_VERSION_MAJOR}.${MapServer_VERSION_MINOR}.${MapServer_VERSION_REVISION}")
  set (MapServer_VERSION_STRING "${MapServer_VERSION_STRING}${MapServer_VERSION_SUFFIX}")
endif(MapServer_IS_DEV_VERSION)
MATH(EXPR MapServer_VERSION_NUM "${MapServer_VERSION_MAJOR}*10000+${MapServer_VERSION_MINOR}*100+${MapServer_VERSION_REVISION}")

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
if (APPLE)
  set(CMAKE_FIND_FRAMEWORK "LAST")
endif (APPLE)


macro (ms_link_libraries)
  target_link_libraries(mapserver ${ARGV})
  if(BUILD_STATIC)
    target_link_libraries(mapserver_static ${ARGV})
  endif(BUILD_STATIC)
endmacro()

macro( report_optional_not_found component )
  message(SEND_ERROR "${component} library/component/dependency could not be found.
  HINTS:
  - disable ${component} support by adding -DWITH_${component}=0
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_mandatory_not_found component )
  message(SEND_ERROR "${component} library/component could not be found and is a mandatory dependency
  HINT:
  - add the ${component} install directory to the CMAKE_PREFIX_PATH variable (-DCMAKE_PREFIX_PATH=\"/path/to/${component}-install-dir;/path/to/other/dirs\"")
endmacro()
macro( report_dependency_error component dependency)
  message(SEND_ERROR "${component} support requires ${dependency} support, however ${dependency} support has been disabled.
  HINTS:
  - re-run with -DWITH_${dependency}=1 (or without -DWITH_${dependency}=0)
  - disable ${component} support by adding -DWITH_${component}=0"
  )
endmacro()

SET(CMAKE_REQUIRED_INCLUDES "math.h")
if(CMAKE_COMPILER_IS_GNUCXX)
   SET(CMAKE_REQUIRED_LIBRARIES "m")
endif(CMAKE_COMPILER_IS_GNUCXX)
check_function_exists("strrstr"          HAVE_STRRSTR)
check_function_exists("strcasecmp"  HAVE_STRCASECMP)
check_function_exists("strcasestr"  HAVE_STRCASESTR)
check_function_exists("strdup"  HAVE_STRDUP)
check_function_exists("strlcat"  HAVE_STRLCAT)
check_function_exists("strlcpy"  HAVE_STRLCPY)
check_function_exists("strlen"  HAVE_STRLEN)
check_function_exists("strncasecmp"  HAVE_STRNCASECMP)
check_function_exists("vsnprintf"  HAVE_VSNPRINTF)
check_function_exists("lrintf" HAVE_LRINTF)
check_function_exists("lrint" HAVE_LRINT)

check_include_file(dlfcn.h HAVE_DLFCN_H)


check_c_source_compiles("
int main(int argc, char **argv) {
   long x=0,y=0;
   for(x=0;x<5;x++) {
     if(y>1) break;
     y=__sync_fetch_and_add(&x,1);
   }
}" HAVE_SYNC_FETCH_AND_ADD)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

#options suported by the cmake builder
option(WITH_PROJ "Choose if reprojection support should be built in" ON)
option(WITH_KML "Enable native KML output support (requires libxml2 support)" OFF)
option(WITH_SOS "Enable SOS Server support (requires PROJ and libxml2 support)" OFF)
option(WITH_WMS "Enable WMS Server support (requires proj support)" ON)
option(WITH_GD "Choose if (old) GD support should be built in" OFF)
option(WITH_FRIBIDI "Choose if FriBidi glyph shaping support should be built in (usefull for left-to-right languages)" ON)
option(WITH_ICONV "Choose if Iconv Internationalization support should be built in" ON)
option(WITH_CAIRO "Choose if CAIRO  rendering support should be built in (required for SVG and PDF output)" ON)
option(WITH_SVGCAIRO "Choose if SVG symbology support (via libsvgcairo) should be built in (requires cairo, libsvg, libsvg-cairo. Incompatible with librsvg)" OFF)
option(WITH_RSVG "Choose if SVG symbology support (via librsvg) should be built in (requires cairo, librsvg. Incompatible with libsvg-cairo)" OFF)
option(WITH_MYSQL "Choose if MYSQL joining support should be built in" OFF)
option(WITH_FCGI "Choose if FastCGI support should be built in" ON)
option(WITH_GEOS "Choose if GEOS geometry operations support should be built in" ON)
option(WITH_POSTGIS "Choose if Postgis input support should be built in" ON)
option(WITH_GDAL "Choose if GDAL input raster support should be built in" ON)
option(WITH_OGR "Choose if OGR/GDAL input vector support should be built in" ON)
option(WITH_CLIENT_WMS "Enable Client WMS Layer support (requires CURL and GDAL support)" OFF)
option(WITH_CLIENT_WFS "Enable Client WMS Layer support (requires CURL and OGR support)" OFF)
option(WITH_CURL "Enable Curl HTTP support (required for wms/wfs client, and remote SLD)" OFF)
option(WITH_WFS "Enable WFS Server support (requires PROJ and OGR support)" ON)
option(WITH_WCS "Enable WCS Server support (requires PROJ and GDAL support)" ON)
option(WITH_LIBXML2 "Choose if libxml2 support should be built in (used for sos, wcs 1.1,2.0 and wfs 1.1)" ON)
option(WITH_THREAD_SAFETY "Choose if a thread-safe version of libmapserver should be built (only recommended for some mapscripts)" OFF)
option(WITH_GIF "Enable GIF support (for PIXMAP loading)" ON)
option(WITH_PYTHON "Enable Python mapscript support" OFF)
option(WITH_PHP "Enable Python mapscript support" OFF)
option(WITH_PERL "Enable Perl mapscript support" OFF)
option(WITH_RUBY "Enable Ruby mapscript support" OFF)
option(WITH_JAVA "Enable Java mapscript support" OFF)
option(WITH_CSHARP "Enable C# mapscript support" OFF)
option(WITH_POINT_Z_M "include Z and M coordinates in point structure (advanced, not recommended)" OFF)
option(WITH_ORACLESPATIAL "include oracle spatial database input support" OFF)
option(WITH_ORACLE_PLUGIN "include oracle spatial database input support as plugin" OFF)
option(WITH_MSSQL2008 "include mssql 2008 database input support as plugin" OFF)
option(WITH_SDE_PLUGIN "include ArcSDE support as a plugin (must specify SDE_INCLUDE_DIR and SDE_LIBRARY_DIR)." OFF)
option(WITH_SDE "include ArcSDE support. Add -DSDE_VERSION=91 to use 9.1 arcSDE version" OFF)
option(WITH_EXEMPI "include xmp output metadata support" OFF)
option(WITH_XMLMAPFILE "include native xml mapfile support (requires libxslt/libexslt)" OFF)

option(BUILD_STATIC "Also build a static version of mapserver" OFF)
option(LINK_STATIC_LIBMAPSERVER "Link to static version of libmapserver (also for mapscripts)" OFF)
option(WITH_APACHE_MODULE "include (experimental) support for apache module" OFF)
option(WITH_GENERIC_NINT "generic rounding" OFF)

#TODO: USE_OGL? , USE_SDE, USE_CLUSTER_EXTERNAL USE_CLUSTER_PLUGIN, USE_MSSQL2008, USE_MSSQL2008_PLUGIN
# SIGNORE_MISSING_DATA, CGI_CL_DEBUG_ARGS, EXTRA DEBUG FLAGS?,
# PERLV_ld_DETECT?

# Add compiler flags for warnings
if(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wdeclaration-after-statement")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
endif()
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
SET(CMAKE_MACOSX_RPATH ON)

if(LINK_STATIC_LIBMAPSERVER)
  set(BUILD_STATIC 1)
  set(MAPSERVER_LIBMAPSERVER mapserver_static)
else(LINK_STATIC_LIBMAPSERVER)
  set(MAPSERVER_LIBMAPSERVER mapserver)
endif(LINK_STATIC_LIBMAPSERVER)

set(agg_SOURCES
renderers/agg/src/agg_arc.cpp
renderers/agg/src/agg_vcgen_dash.cpp
renderers/agg/src/agg_vcgen_contour.cpp
renderers/agg/src/agg_curves.cpp
renderers/agg/src/agg_embedded_raster_fonts.cpp
renderers/agg/src/agg_trans_affine.cpp
renderers/agg/src/agg_vcgen_stroke.cpp
renderers/agg/src/agg_font_freetype.cpp
renderers/agg/src/agg_line_aa_basics.cpp
renderers/agg/src/clipper.cpp
)
include_directories(renderers/agg/include)

if(WIN32)
  set(REGEX_SOURCES ${REGEX_DIR}/regex.c)
  include_directories(${REGEX_DIR})
  add_definitions(-DREGEX_MALLOC -DUSE_GENERIC_MS_NINT -DHAVE_STRING_H)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
  set(REGEX_MALLOC 1)
  set(USE_GENERIC_MS_NINT 1)
  set(HAVE_STRING_H 0)
else(WIN32)
  set(REGEX_SOURCES "")
endif(WIN32)

set(mapserver_SOURCES
cgiutil.c mapgeos.c maporaclespatial.c mapsearch.c mapwms.c classobject.c
mapgml.c mapoutput.c mapwmslayer.c layerobject.c mapgraticule.c mapows.c
mapservutil.c mapxbase.c maphash.c mapowscommon.c mapshape.c mapxml.c mapbits.c
maphttp.c mapparser.c mapstring.c mapxmp.c mapcairo.c mapimageio.c
mappluginlayer.c mapsymbol.c mapchart.c mapimagemap.c mappool.c maptclutf.c
mapcluster.c mapio.c mappostgis.c maptemplate.c mapcontext.c mapjoin.c
mappostgresql.c mapthread.c mapcopy.c maplabel.c mapprimitive.c maptile.c
mapcpl.c maplayer.c mapproject.c maptime.c mapcrypto.c maplegend.c hittest.c
mapprojhack.c maptree.c mapdebug.c maplexer.c mapquantization.c mapunion.c
mapdraw.c maplibxml2.c mapquery.c maputil.c strptime.c mapdrawgdal.c
mapraster.c mapuvraster.c mapdummyrenderer.c mapobject.c maprasterquery.c
mapwcs.c maperror.c mapogcfilter.c mapregex.c mapwcs11.c mapfile.c
mapogcfiltercommon.c maprendering.c mapwcs20.c mapgd.c mapogcsld.c
mapresample.c mapwfs.c mapgdal.c mapogcsos.c mapscale.c mapwfs11.c
mapgeomtransform.c mapogroutput.c mapsde.c mapwfslayer.c mapagg.cpp mapkml.cpp
mapgeomutil.cpp mapkmlrenderer.cpp
mapogr.cpp mapcontour.c mapsmoothing.c ${REGEX_SOURCES})

add_library(mapserver SHARED ${mapserver_SOURCES} ${agg_SOURCES})
set_target_properties( mapserver  PROPERTIES
  VERSION ${MapServer_VERSION_STRING}
  SOVERSION 1
) 
if(BUILD_STATIC)
  add_library(mapserver_static STATIC ${mapserver_SOURCES} ${agg_SOURCES})
  set_target_properties( mapserver_static PROPERTIES
    VERSION ${MapServer_VERSION_STRING}
    SOVERSION 1
  ) 
endif(BUILD_STATIC)

#SOVERSION is not necessarily the same as the
#major version. The rule is that any breakage of the ABI must be
#indicated by incrementing the SOVERSION. So, adding e.g. functions is no
#problem, modifying argument lists or removing functions would required
#the SOVERSION to be incremented. Similar rules hold of course for
#non-opaque data-structures.

add_executable(mapserv mapserv.c)
target_link_libraries(mapserv ${MAPSERVER_LIBMAPSERVER})
add_executable(shp2img shp2img.c)
target_link_libraries(shp2img ${MAPSERVER_LIBMAPSERVER})
add_executable(shptree shptree.c)
target_link_libraries(shptree ${MAPSERVER_LIBMAPSERVER})
add_executable(shptreevis shptreevis.c)
target_link_libraries(shptreevis ${MAPSERVER_LIBMAPSERVER})
add_executable(sortshp sortshp.c)
target_link_libraries(sortshp ${MAPSERVER_LIBMAPSERVER})
add_executable(legend legend.c)
target_link_libraries(legend ${MAPSERVER_LIBMAPSERVER})
add_executable(scalebar scalebar.c)
target_link_libraries(scalebar ${MAPSERVER_LIBMAPSERVER})
add_executable(msencrypt msencrypt.c)
target_link_libraries(msencrypt ${MAPSERVER_LIBMAPSERVER})
add_executable(tile4ms tile4ms.c)
target_link_libraries(tile4ms ${MAPSERVER_LIBMAPSERVER})
add_executable(shptreetst shptreetst.c)
target_link_libraries(shptreetst ${MAPSERVER_LIBMAPSERVER})


find_package(PNG)
if(PNG_FOUND)
  include_directories(${PNG_INCLUDE_DIR})
  ms_link_libraries( ${PNG_LIBRARIES})
  set(USE_PNG 1)
else(PNG_FOUND)
  report_mandatory_not_found(PNG)
endif(PNG_FOUND)

find_package(JPEG)
if(JPEG_FOUND)
  include_directories(${JPEG_INCLUDE_DIR})
  ms_link_libraries( ${JPEG_LIBRARY})
  set(USE_JPEG 1)
else(JPEG_FOUND)
  report_mandatory_not_found(JPEG)
endif(JPEG_FOUND)

find_package(Freetype)
if(NOT FREETYPE_FOUND)
  report_mandatory_not_found(FREETYPE)
endif(NOT FREETYPE_FOUND)
include_directories(${FREETYPE_INCLUDE_DIR})
ms_link_libraries( ${FREETYPE_LIBRARY})


if(WITH_PROJ)
  find_package(Proj)
  if(NOT PROJ_FOUND)

=== mapscript/csharp/CMakeLists.txt ===
FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})

FIND_PROGRAM (CSHARP_COMPILER NAMES csc gmcs gmcs2)

IF (CSHARP_COMPILER)
	MESSAGE(STATUS "Found CSharp compiler: ${CSHARP_COMPILER}")
ELSE (CSHARP_COMPILER)
	MESSAGE(FATAL_ERROR "Could not find csharp compiler")
ENDIF (CSHARP_COMPILER)

if (WIN32)
  if (NOT MSVC71)
    if (CMAKE_CL_64)
      set(PLATFORM_TARGET /platform:anycpu)
    else(CMAKE_CL_64)
      set(PLATFORM_TARGET /platform:x86)
    endif(CMAKE_CL_64)
  endif (NOT MSVC71)
  if (MSVC10)
      set(PLATFORM_TARGET ${PLATFORM_TARGET} /define:CLR4)
  endif (MSVC10)
endif(WIN32)

MARK_AS_ADVANCED(CSHARP_COMPILER)

include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/csharp)
SET (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}")
SET( CMAKE_SWIG_FLAGS -namespace OSGeo.MapServer ${MAPSERVER_COMPILE_DEFINITIONS} -DWIN32)
SWIG_ADD_MODULE(csharpmapscript csharp ../mapscript.i)

set_target_properties(csharpmapscript PROPERTIES OUTPUT_NAME "mapscript")

SWIG_LINK_LIBRARIES(csharpmapscript ${MAPSERVER_LIBMAPSERVER})

ADD_CUSTOM_COMMAND(TARGET csharpmapscript
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      POST_BUILD
                      COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /t:library /out:mapscript_csharp.dll *.cs config\\AssemblyInfo.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shpdump.exe examples\\shpdump.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawmap.exe examples\\drawmap.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:shapeinfo.exe examples\\shapeinfo.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:drawquery.exe examples\\drawquery.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:getbytes.exe examples\\getbytes.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:HTMLtemplate.exe examples\\HTMLtemplate.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /out:RFC24.exe examples\\RFC24.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirect.exe examples\\drawmapDirect.cs
					  COMMAND ${CSHARP_COMPILER} ${PLATFORM_TARGET} /r:mapscript_csharp.dll /r:System.Drawing.dll /out:drawmapDirectPrint.exe examples\\drawmapDirectPrint.cs	
                      COMMENT "Compiling c# source files"
                      )

#get_target_property(LOC_MAPSCRIPT_LIB ${SWIG_MODULE_csharpmapscript_REAL_NAME} LOCATION)
#install(FILES ${LOC_MAPSCRIPT_LIB} DESTINATION lib)

=== mapscript/java/CMakeLists.txt ===
FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})

FIND_PACKAGE(JNI)
FIND_PACKAGE(Java)
if(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)
   message(SEND_ERROR "Could not find required Java componenents. Try setting the JAVA_HOME environment variable (required on e.g. Ubuntu)")
endif(NOT JNI_INCLUDE_DIRS OR NOT Java_JAVAC_EXECUTABLE OR NOT Java_JAR_EXECUTABLE)

INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})
include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/java)
SET (CMAKE_SWIG_OUTDIR "${CMAKE_CURRENT_BINARY_DIR}/edu/umn/gis/mapscript")
SET(CMAKE_SWIG_FLAGS -package edu.umn.gis.mapscript)
SWIG_ADD_MODULE(javamapscript java ../mapscript.i)

SWIG_LINK_LIBRARIES(javamapscript ${MAPSERVER_LIBMAPSERVER})

ADD_CUSTOM_COMMAND(TARGET javamapscript
                      WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                      POST_BUILD
                      COMMAND ${Java_JAVAC_EXECUTABLE} edu/umn/gis/mapscript/*.java
                      COMMAND ${Java_JAR_EXECUTABLE} cf mapscript.jar edu
                      COMMENT "Compiling java source files, creating mapscript.jar"
                      )

get_target_property(LOC_MAPSCRIPT_LIB ${SWIG_MODULE_javamapscript_REAL_NAME} LOCATION)
install(FILES ${LOC_MAPSCRIPT_LIB} DESTINATION lib)

=== mapscript/ruby/CMakeLists.txt ===
FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})
FIND_PACKAGE(Ruby REQUIRED)
INCLUDE_DIRECTORIES(${RUBY_INCLUDE_DIRS})
include_directories(${PROJECT_SOURCE_DIR}/mapscript/swiginc)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/)
include_directories(${PROJECT_SOURCE_DIR}/mapscript/ruby)
SWIG_ADD_MODULE(rubymapscript ruby ../mapscript.i)

SWIG_LINK_LIBRARIES(rubymapscript ${RUBY_LIBRARY} ${MAPSERVER_LIBMAPSERVER})

set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES PREFIX "")
set_target_properties(${SWIG_MODULE_rubymapscript_REAL_NAME} PROPERTIES OUTPUT_NAME mapscript)

get_target_property(LOC_MAPSCRIPT_LIB ${SWIG_MODULE_rubymapscript_REAL_NAME} LOCATION)
execute_process(COMMAND ${RUBY_EXECUTABLE} -r rbconfig -e "puts RbConfig::CONFIG['archdir']" OUTPUT_VARIABLE RUBY_ARCHDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
install(FILES ${LOC_MAPSCRIPT_LIB} DESTINATION ${RUBY_ARCHDIR})

=== debian/changelog ===
mapserver (6.4.0-3) unstable; urgency=low

  [ Bas Couwenberg ]
  * Drop obsolete Build-Depends:
    - sharutils (AGG no longer built separately)
    - libsdl1.2-dev (AGG examples no longer built)
    - libogdi3.2-dev (no longer used)
    - libpam0g-dev (no longer used),
    - libreadline-dev (no longer used),
    - libedit-dev (no longer used),
    - libepsilon-dev (no longer used),
  * Update debian watch file:
    - Drop uupdate action
    - Handle common mistakes
  * Remove debconf translations, debconf template no longer used.

  [ Francesco Paolo Lovergine ]
  * Now build-dep on (versioned) libgdal-dev instead of (obsolete) libgdal1-dev. 
  * Added a new patch freetype2-include-dir.patch to fix problem in
    determining the correct FreeType2 include directory (why is it not using
    freetype-config?).

 -- Francesco Paolo Lovergine <frankie@debian.org>  Wed, 11 Dec 2013 14:42:31 +0100

mapserver (6.4.0-2) unstable; urgency=low

  * Also include mapserver-config.h and mapserver-version.h in dev package.
    Required to build MapCache with MapServer support.
  * Use php5enmod and php5dismod instead of installing the ini directly.
    (closes: #667771)
  * Add patch to export mapserver cmake package for external projects.
  * Add versioned Breaks/Replaces for dev package.
  * Drop transitional packages and Breaks/Replaces for libmapserver.
    (closes: #723979)
  * Drop unused lintian-overrides for php5-mapscript.
  * Build-Depend on libperl-dev so cmake can find PerlLibs.
    (closes: #724259)

 -- Bas Couwenberg <sebastic@xs4all.nl>  Thu, 19 Sep 2013 19:52:12 +0200

mapserver (6.4.0-1) unstable; urgency=low

  * New upstream release: 6.4.0.
  * Build system changed from autotools to cmake.
  * Update Build-Depends to include: libgif-dev, librsvg2-dev, pkg-config.
  * Update hardening.patch for CMake build.
  * Drop patches:
    - fixmapscriptvars.patch (mapscriptvars no longer used)
    - php_segfault.patch (applied upstream)
    - mapows-contenttype.patch (applied upstream)
    - shp2img-typo.patch (applied upstream)
  * Add patch to fix the Perl mapscript module installation directory:
    perl-mapscript-install.patch
  * Drop ruby1.8 mapscript package for ruby1.8-removal transition.
  * Rename libruby-mapscript to ruby-mapscript. (closes: #722394)
  * Don't install Ruby mapscript in /usr/lib/ruby, use vendor_ruby instead.
  * SONAME of libmapserver changed from libmapserver-6.2.1.so to
    libmapserver.so.1.
  * Use pkgkde-gensymbols & pkgkde-symbolshelper to handle C++ symbols.
  * Use upstream version without debian revision when generating symbols.
  * Update libmapserver symbols file for 6.4.0 on amd64.
  * Add patch to install ruby mapscript into vendorarchdir instead of archdir.
  * Enable verbose make output.

 -- Bas Couwenberg <sebastic@xs4all.nl>  Tue, 17 Sep 2013 17:16:30 +0200

=== debian/control ===
Source: mapserver
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Alan Boudreault <aboudreault@mapgears.com>,
           Bas Couwenberg <sebastic@xs4all.nl>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1.1),
               libcurl4-gnutls-dev,
               libpng-dev,
               libjpeg-dev,
               zlib1g-dev (>= 1.1.4),
               libgd-dev (>= 2.1.0~rc1-2),
               libfreetype6-dev (>= 2.0.9),
               libgdal-dev (>= 1.10.1-0~),
               libproj-dev,
               libgeos-dev (>= 3.3.1-1~),
               libfribidi-dev,
               libcairo2-dev,
               libgif-dev,
               librsvg2-dev,
               libpq-dev,
               php5-dev,
               swig,
               libperl-dev,
               python-all (>= 2.6.6-3~),
               python-all-dev (>= 2.6.6-3~),
               ruby1.9.1,
               ruby1.9.1-dev,
               libfcgi-dev,
               libxml2-dev,
               libxslt1-dev,
               pkg-kde-tools,
               chrpath,
               cmake (>= 2.8.0),
               pkg-config,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Build-Conflicts: libcurl3-openssl-dev
XS-Ruby-Versions: ruby1.9.1
Standards-Version: 3.9.4
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-grass/mapserver.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/mapserver.git
Homepage: http://www.mapserver.org

Package: libmapserver1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          php5-mapscript,
          python-mapscript,
          ruby-mapscript
Pre-Depends: ${misc:Pre-Depends}
Description: Shared library for MapServer
 This package contains the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: libmapserver1-dev
Architecture: any
Section: libdevel
Depends: libmapserver1 (= ${binary:Version}),
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          php5-mapscript,
          python-mapscript,
          ruby-mapscript
Breaks: libmapserver-dev (<< 6.2.1-3~),
        libmapserver-6.2.1-dev (<< 6.4.0-1~)
Replaces: libmapserver-dev (<< 6.2.1-3~),
          libmapserver-6.2.1-dev (<< 6.4.0-1~)
Description: Shared library development files for MapServer
 This package contains the development files for the shared library.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: cgi-mapserver
Architecture: any
Section: web
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc,
          libmapscript-perl,
          php5-mapscript,
          python-mapscript,
          ruby-mapscript
Description: CGI executable for MapServer
 This package contains the mapserv CGI program. It provides the
 MapServer template language, and can be used to implement Web Map
 Service applications.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-bin
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cgi-mapserver,
          mapserver-doc,
          shapelib,
          libmapscript-perl,
          php5-mapscript,
          python-mapscript,
          ruby-mapscript
Description: MapServer utilities
 This package provides command-line utilities for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: mapserver-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: cgi-mapserver,
          libmapscript-perl,
          php5-mapscript,
          python-mapscript,
          ruby-mapscript
Description: documentation for MapServer
 This package provides some brief documentation for MapServer.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards. Scripting
 functionality in MapScript is provided by the suggested mapscript
 library packages.

Package: php5-mapscript
Architecture: any
Section: php
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Description: php5-cgi module for MapServer
 PHP MapScript provides MapServer functions for PHP scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: libmapscript-perl
Architecture: any
Section: perl
Depends: ${perl:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Conflicts: perl-mapscript
Provides: perl-mapscript
Replaces: perl-mapscript
Description: Perl MapServer module
 Perl MapScript module provides MapServer functions for Perl scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: python-mapscript
Architecture: any
Section: python
Depends: ${python:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Provides: ${python:Provides}
Description: Python library for MapServer
 Python MapScript provides MapServer functions for Python scripts.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

Package: libmapscript-ruby
Architecture: all
Section: oldlibs
Depends: ruby-mapscript,
         ${misc:Depends}
Description: Transitional dummy package for ruby-mapscript
 This is a transitional dummy package to ease upgrades to the
 ruby-mapscript package. It can safely be removed.

Package: libmapscript-ruby1.8
Architecture: any
Section: oldlibs
Depends: ruby-mapscript,
         ${misc:Depends}
Description: Transitional package from libmapscript-ruby1.8 to ruby-mapscript
 This is a transitional dummy package to ease upgrades from the
 libmapscript-ruby1.8 package to the ruby-mapscript package.
 It can safely be removed.

Package: libmapscript-ruby1.9.1
Architecture: any
Section: oldlibs
Depends: ruby-mapscript,
         ${misc:Depends}
Description: Transitional package from libmapscript-ruby1.9.1 to ruby-mapscript
 This is a transitional dummy package to ease upgrades from the
 libmapscript-ruby1.9.1 package to the ruby-mapscript package.
 It can safely be removed.

Package: ruby-mapscript
Architecture: any
Section: ruby
Depends: ruby1.9.1,
         ${shlibs:Depends},
         ${misc:Depends}
Suggests: mapserver-bin,
          mapserver-doc
Breaks: libmapscript-ruby (<< 6.4.0-1~),
        libmapscript-ruby1.8 (<< 6.4.0-1~),
        libmapscript-ruby1.9.1 (<< 6.4.0-1~)
Provides: libmapscript-ruby,
          libmapscript-ruby1.8,
          libmapscript-ruby1.9.1
Replaces: libmapscript-ruby (<< 6.4.0-1~),
          libmapscript-ruby1.8 (<< 6.4.0-1~),
          libmapscript-ruby1.9.1 (<< 6.4.0-1~)
XB-Ruby-Versions: ruby1.9.1
Description: MapServer library for Ruby
 Ruby MapScript provides MapServer functions for Ruby scripts.
 .
 This package contains examples and the MapServer functions for Ruby.
 .
 MapServer is a CGI-based framework for Internet map services which
 supports Open Geospatial Consortium (OGC) standards.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# Enable hardening build flags, except:
#  pie: causes build failure
export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

CFLAGS+=$(CPPFLAGS)
CFLAGS+=$(LDFLAGS)

PHP5API=$(shell php-config5 --phpapi)
MANPAGES:=$(wildcard debian/man/*.*.xml)

MS_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p')

MAKE_VERBOSE=1

COMMON_CONFIG=	-DCMAKE_INSTALL_PREFIX=/usr \
		-DWITH_PROJ=1 \
		-DWITH_KML=1 \
		-DWITH_SOS=1 \
		-DWITH_WMS=1 \
		-DWITH_GD=1 \
		-DWITH_FRIBIDI=1 \
		-DWITH_ICONV=1 \
		-DWITH_CAIRO=1 \
		-DWITH_SVGCAIRO=0 \
		-DWITH_RSVG=1 \
		-DWITH_MYSQL=0 \
		-DWITH_FCGI=1 \
		-DWITH_GEOS=1 \
		-DWITH_POSTGIS=1 \
		-DWITH_GDAL=1 \
		-DWITH_OGR=1 \
		-DWITH_CURL=1 \
		-DWITH_CLIENT_WMS=1 \
		-DWITH_CLIENT_WFS=1 \
		-DWITH_WFS=1 \
		-DWITH_WCS=1 \
		-DWITH_LIBXML2=1 \
		-DWITH_THREAD_SAFETY=1 \
		-DWITH_GIF=1 \
		-DWITH_PYTHON=1 \
		-DWITH_PHP=1 \
		-DWITH_PERL=1 \
		-DWITH_RUBY=1 \
		-DWITH_JAVA=0 \
		-DWITH_CSHARP=0 \
		-DWITH_ORACLESPATIAL=0 \
		-DWITH_ORACLE_PLUGIN=0 \
		-DWITH_MSSQL2008=0 \
		-DWITH_SDE_PLUGIN=0 \
		-DWITH_SDE=0 \
		-DWITH_EXEMPI=0 \
		-DWITH_XMLMAPFILE=0

HARDENING_CONFIG= \
		-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
		-DCMAKE_MODULE_LINKER_FLAGS="$(LDFLAGS)" \
		-DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)"

%:
	dh $@ --with python2,pkgkde_symbolshelper

override_dh_auto_clean:
	dh_clean

	-$(RM) -f $(CURDIR)/debian/man/*.1
	-$(RM) -rf build/

override_dh_auto_configure:
	mkdir -p build && cd build && cmake .. -DCMAKE_BUILD_TYPE=Release $(HARDENING_CONFIG) $(COMMON_CONFIG)

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	$(MAKE) -C build VERBOSE=$(MAKE_VERBOSE)

override_dh_auto_test:
	# msautotest submodule is not used

override_dh_auto_install:
	$(MAKE) -C build install DESTDIR=$(CURDIR)/debian/tmp VERBOSE=$(MAKE_VERBOSE)

	-mkdir -p $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	-mv -v $(CURDIR)/debian/tmp/usr/lib/libmapserver*.so* $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	-sed -i "s/lib\/libmapserver/lib\/$(DEB_HOST_MULTIARCH)\/libmapserver/g" $(CURDIR)/debian/tmp/usr/share/*/cmake/*.cmake

	# removing embedded rpath in binaries
	-find $(CURDIR)/debian/tmp/usr/bin -type f -exec chrpath --delete {} \;

	# removing embedded rpath in libraries
	-find $(CURDIR)/debian/tmp/usr/lib -name "*.so*" -type f -exec chrpath --delete {} \;

	# CGI mapserver
	-mkdir -p debian/tmp/usr/lib/cgi-bin
	install -m755 debian/tmp/usr/bin/mapserv debian/tmp/usr/lib/cgi-bin/mapserv

	# PHP mapscript
	echo 'misc:Depends=phpapi-'$(PHP5API) >> debian/php5-mapscript.substvars

	-mkdir -p debian/tmp/etc/php5/mods-available/
	install -m644 debian/mapscript.ini debian/tmp/etc/php5/mods-available/

override_dh_installchangelogs:
	dh_installchangelogs HISTORY.TXT

override_dh_installexamples:
	dh_installexamples

	chmod a-x $(CURDIR)/debian/php*-mapscript/usr/share/doc/php*-mapscript/examples/*.phtml

override_dh_install:
	dh_install --autodest --list-missing

override_dh_compress:
	dh_compress -X.xml -X.xsd -X.xsl

override_dh_makeshlibs:
	dh_makeshlibs -Xphp_mapscript -- -c0 -v$(MS_VERSION)

override_dh_python2:
	dh_python2 -ppython-mapscript

override_dh_perl:
	dh_perl -plibmapscript-perl
